from typing import Protocol, TypeVar, runtime_checkable

__all__ = ['Ordinal', 'Cardinal']

T_co = TypeVar('T_co', covariant=True)
T_contra = TypeVar('T_contra', contravariant=True)


@runtime_checkable
class Ordinal(Protocol[T_contra]):
    '''`Ordianal` objects support comparison (==, !=, >, <, >=, <=).'''
    def __eq__(self, other: T_contra, /) -> bool: ...
    def __ne__(self, other: T_contra, /) -> bool: ...
    def __lt__(self, other: T_contra, /) -> bool: ...
    def __le__(self, other: T_contra, /) -> bool: ...
    def __gt__(self, other: T_contra, /) -> bool: ...
    def __ge__(self, other: T_contra, /) -> bool: ...
    def __hash__(self) -> int: ...


@runtime_checkable
class Cardinal(Ordinal[T_contra], Protocol[T_co, T_contra]):
    '''`Cardinal` objects are ordinal, 
    and support addition (+) and subtraction (-).
    '''
    def __add__(self, other: T_contra, /) -> T_co: ...
    def __sub__(self, other: T_contra, /) -> T_co: ...
